<?php

// table_edit2.inc.php, 1.8+calc0.4+func0.2 2007/03/23 taru        plugin

define('PLUGIN_TABLE_EDIT2_TEXT_SIZE',  58);
define('PLUGIN_TABLE_EDIT2_TEXTAREA_ROWS_LINE',  4);		// textarea 06.11.12
define('PLUGIN_TABLE_EDIT2_TEXTAREA_COLS_SIZE', 40);
define('PLUGIN_TABLE_EDIT2_TEXTAREA',  'text');				// textarea 06.11.13
define('PLUGIN_TABLE_EDIT2_TD_SHOW', TRUE);			// td_edit_and_add	06.09.16 TRUE or FALSE
define('PLUGIN_TABLE_EDIT2_TR_SHOW', TRUE);			// td_edit_and_add	07.03.19 TRUE or FALSE
define('PLUGIN_TABLE_EDIT2_ADD_SHOW', 1);
if (!defined('IMAGE_URI')) define('IMAGE_URI', IMAGE_DIR);
define('PLUGIN_TABLE_EDIT2_CALC', 1);

function plugin_table_edit2_convert()
{
	global $vars, $edit_auth, $edit_auth_pages;
	$script_uri = get_script_uri();
	static $number = array();
	$line_count = 1;
	$table_end = 0;
	$table_sub_num = 1;
	$page = isset($vars['page']) ? $vars['page'] : '';
	if (! isset($number[$page])) $number[$page] = 1;
	$count = $number[$page]++;
	$r_page = rawurlencode($page);
	if (! function_exists('_')) table_edit2_message();

	$opt = array(
		'edit' => 'on',
		'auth' => '',
		'table_mod' => '',
		'dot' => '0',
		'td_edit' => 'on',
		'tr_edit' => 'on',
	);

	if (! class_exists('auth')) { table_edit2_auth(); }
	$auth_chk = auth::check_auth();
	foreach($edit_auth_pages as $key=>$val){
		if (preg_match($key, $page) && $edit_auth){
			$opt['edit'] = 'off';
			if(! empty($auth_chk)){
				$opt['edit'] = 'on';
			}
		}
	}

	$head_button = '';
	$body = '';
	$body_table = '';

	$args = func_get_args();
	$arg = array_pop($args);
	foreach ($args as $opt_key) {
		list($key, $val) = explode('=', strtolower($opt_key));
		$opt[$key] = htmlspecialchars($val);
	}

	// if (PKWK_READONLY) {
	if (auth::check_role('readonly') || is_freeze($page)) {	// || is_freeze($page) 
		$opt['edit'] = 'off';
	}

	// calc on off
	$opt['calc'] = isset($opt['calc']) ? PLUGIN_TABLE_EDIT2_CALC : 0;
	if ($opt['calc'] === 1) {
		$calc = new TableEdit2Calc;
		$calc_chk = 'on';
	}

	//td edit
	if (PLUGIN_TABLE_EDIT2_TD_SHOW === TRUE) {
		$td_edit = ($opt['td_edit'] == 'off') ? 0 : 1;
	} else {
		$td_edit = 0;
	}
	//tr edit
	if (PLUGIN_TABLE_EDIT2_TR_SHOW === TRUE) {
		$tr_edit = ($opt['tr_edit'] == 'off') ? 0 : 1;
	} else {
		$tr_edit = 0;
	}

	// open or close
	$s_table_close = _('close');
	$s_table_open  = _('open');
	if ($opt['table_mod'] != 'off' && $opt['edit'] != 'off'){
		if ($opt['table_mod'] == 'open' || $opt['table_mod'] == ''){
			$image_png = 'close.png" width="11" height="11" alt="" title="' . $s_table_close . '"';
			$table_mod = 'close';
		} else if ($opt['table_mod'] == 'close'){
			$image_png = 'paraedit.png" width="9" height="9" alt="" title="' . $s_table_open . '"';
			$opt['edit'] = 'off';
			$table_mod = 'open';
		}
		$head_button = '<div style="float:right;" id="TableEdit2TableNumber' . $count . '"><a href="' . $script_uri
			  . "?plugin=table_edit2&amp;refer=$r_page&amp;table_mod=" . $table_mod . "&amp;table_num=$count"
			  . '"><img src="' . IMAGE_URI . 'plus/' . $image_png . '/></a></div><div style="float:both;"></div>';
	}
	if ($opt['edit'] != 'off') $form = new TableEdit2Form;		//form func


	$arg = preg_replace(array("[\\r|\\n]","[\\r]"), array("\n","\n"), $arg);
	$args = explode("\n", $arg);

	if ( $opt['edit'] != 'off' || $calc_chk == 'on' || isset($opt['edit']) ) $editoff_or_calcon = 1;		//06.09.19

	foreach ($args as $args_line) {
		if (preg_match('/^\|(.+)\|([hHfFcC]?)$/', $args_line, $matches) && $editoff_or_calcon){

			$match_cells = explode("|", $matches[1]);
			if ($line_count === 1) $r_cell_count = count($match_cells);		//06.11.17 sort

			if ( $calc_chk == 'on' ){		//calc  06.09.12 taru

				if (strtolower($matches[2]) == "c") $calc->cell_format = '';
				$calc->line_count  = $line_count;
				$calc->comma = isset($opt['comma']) ? ',' : '';
				$calc->dot   = isset($opt['dot']) ? $opt['dot'] : 0;
				$calc->row = $opt['row'];
				$calc->column = $opt['column'];

				$calc->calc($match_cells);

				$calc->calc_row();

				$cell_count_max = $calc->cell_count;
				$body_table .= $calc->body_table;
			} else {
				$body_table .= '|' . $matches[1] . '|';
			}
			if( $opt['edit'] != 'off' && $tr_edit ){		//edit
				$body_table .= $form->inline('show', $count, $line_count)
							 . $form->inline('tr', $count, $line_count) . '|';
			}
			$body_table .= $matches[2] . "\n";
			$line_count++;
			$table_end = 1;
			$table_header = 1;
		} else {
			if( $table_header === 1 && $opt['edit'] != 'off' && $td_edit){		//td edit and add 06.09.16
				$cell_count = 1;
				$table_line_count = $line_count- 1;
				$body .= '|';
				foreach ($match_cells as $cell){
					$body .= '~' . $form->inline('tdshow', $count, $table_line_count, $table_sub_num, $cell_count)
								 . $form->inline('td', $count, $table_line_count, $table_sub_num, $cell_count) . '|';
					$cell_count++;
				}
				$table_sub_num++;

				if ($calc_chk == 'on' && ($opt['row'] == 'sum' || $opt['row'] == 'average') ) $body .= "|";

				$body .= ($tr_edit) ? '|' : '';
				$body .= "h\n" . $body_table;
				$body_table = '';
				$table_header = 0;
			} else {
				$body .= $body_table;
				$body_table = '';
			}
			if ($calc_chk == 'on' && ($opt['column'] == 'sum' || $opt['column'] == 'average') ) $column_sum_or_avg = 1;
			if ( $table_end && $column_sum_or_avg){		//column
				$cell_calc = '';
				$body .= '|';
				$body .= $calc->calc_column($cell_count_max);
				$body .= ( $opt['edit'] == 'on' && $tr_edit ) ? '|' : '';
				$body .= "\n";
				$table_end = 0;
			}
			$body .= $args_line . "\n";
		}
	}

	$body = convert_html($body);	//06.11.17 sortabletable

	if(exist_plugin_convert('sortabletable') && isset($opt['sort']) && ! $td_edit) {
		$filter = isset($opt['filter']) ? 1 : 0;
		$table_id = "table_edit2_$count";
		$sort = new TableEdit2Sort;
		$sort->sort($opt['sort'],$r_cell_count);
		
		$body = sortabletable_main( $table_id, $body, $sort->sortabletableso, $filter);
	}

	$body = $head_button . $body;
	if (isset($opt['style'])){
		return preg_replace('/<div class="ie5"/', '<div style="' . $opt['style'] . '" class="ie5"', $body);
	} else {
		return $body;
	}
}
class TableEdit2Form
{
	var $c_count = 0;
	var $select_chk;
	var $radio_chk;
	var $bgcolor = array();

	function inline( $edit_mod, $count,$line_count, $table_sub_num , $cell_count)
	{
		
		$table_inline = 'edit_mod=' . $edit_mod;
		$table_inline .= ',table_num=' . $count;
		$table_inline .= ',line_count=' . $line_count;
		if (isset($table_sub_num)) $table_inline .= ',table_sub_num=' . $table_sub_num;
		if (isset($cell_count)) $table_inline .= ',cell_count=' . $cell_count;
		
		return '&table_edit2(' . $table_inline . ');';
	}
	function bgcolor($bg_color)
	{
		$this->c_count = count($bg_color);
		if ($this->c_count){
			if ($this->c_count > 1) {
				foreach($bg_color as $color){
					$color = htmlspecialchars($color);
					$this->bgcolor[] = 'style="background-color:' . $color . ';"';
				}
			} else {
				$this->bgcolor =  array_fill(0, 30, ' style="background-color:' . $bg_color[0] . ';"');
			}
		} else {
			$this->bgcolor = array_fill(0, 30, '');
		}
	}
	function select($select_data, $s_name, $present, $equal = 1)
	{
		$select_list = '';
		$count = 0;
		foreach($select_data as $key => $s_data) {
			$key_data = $equal ? $s_data : $key;
			$selected = ($present == $key_data) ? ' selected="selected"' : '';
			if ( $selected != '' ) $this->select_chk = 1;
			$select_list .= "    <option value=\"$key_data\"{$this->bgcolor[$count]}$selected>$s_data</option>\n";
			$count++;
		}
		$select = "   <select name=\"$s_name\">$select_list</select>\n";
		return $select;
	}
	function radio($radio_data, $r_name, $present, $equal = 1)
	{
		$radio_list = '';
		$count = 0;
		foreach($radio_data as $key => $r_data) {
			$key_data = $equal ? $r_data : $key;
			$checked = ($present == $key_data) ? ' checked="checked"' : '';
			if ( $checked != '' ) $this->radio_chk = 1;
			$radio_list .= "  <input type=\"radio\" name=\"$r_name\" value=\"$key_data\"{$this->bgcolor[$count]}$checked />$r_data\n";
			$count++;
		}
		return $radio_list;
	}
	function text($name, $value = '', $size = null)
	{
		$size = ( isset($size) ) ? ' size="' . $size . '"' : '';
		$text = '<input type="text" name="' . $name
			. '" value="' . $value . '"' . $size . $this->bgcolor[0] . ' />';
		return $text;
	}
	function textarea($name, $value = '', $rows = 2,$cols = 40)
	{
		$textarea = '<textarea name="' . $name
			. '" rows="' . $rows . '" cols="' . $cols . '">' . $value . '</textarea>';
		return $textarea;
	}
	function f_input($type, $name, $value)
	{
		return '   <input type="' . $type . '" name="' . $name . '"  value="' . $value . '" />';
	}
}
function table_edit2_auth()
{
	class auth {
		function check_auth()
		{
			foreach (array('PHP_AUTH_USER', 'AUTH_USER', 'REMOTE_USER', 'LOGON_USER') as $x) {
				if (isset($_SERVER[$x]) && ! empty($_SERVER[$x])) {
					if (! empty($_SERVER['AUTH_TYPE']) && $_SERVER['AUTH_TYPE'] == 'Digest') return $_SERVER[$x];
					$ms = explode('\\', $_SERVER[$x]);
					if (count($ms) == 3) return $ms[2]; // DOMAIN\\USERID
					foreach (array('PHP_AUTH_PW', 'AUTH_PASSWORD', 'HTTP_AUTHORIZATION') as $pw) {
						if (! empty($_SERVER[$pw])) return $_SERVER[$x];
					}
				}
			}
		}
		function check_role()
		{
			return PKWK_READONLY;
		}
	}
}
function table_edit2_message()
{
	function _($message){ return $message; }
}
class TableEdit2Calc
{
	var $comma;
	var $dot;
	var $cell_format = 'RIGHT: ';
	var $body_table;
//	var $cell_calc = '';
	var $cells;
	var $line_count;
	var $cell_count;
	var $calc_cell_count;
	var $row;
	var $column;
//	var $calc_chk;

//	function TableEdit2Calc()
//	{
//		if ( $this->row != '' || $this->column != '' ) $this->calc_chk = 'on';
//	}
	function calc($match_cells)
	{
		$cell_count = 1;
		$this->calc_cell_count = 0;
		$this->body_table = '|';
		foreach ($match_cells as $cell){
			$exp = mb_convert_kana( $cell, "a");
			if ( preg_match_all('/\@([\w]+)\((\d+),(\d+)\)/', $exp, $matc_cell)){		//func 06.09.13
				$exp = $this->cell_func($matc_cell,$cell_count,$exp);
				$cell = $exp;
			}
			if (preg_match('/^[\d\s\+\-\(]+[\d\.\s\+\-\*\/\%\(\)]*$/', $exp) && preg_match('/[\d\s\)]+$/', $exp) && $exp != ''){
				eval("\$cell = $exp;");
				$this->body_table .= $this->format($cell);
				$this->calc_cell_count++;
			} else {
				$this->body_table .= $cell . '|';
			}
			$this->cells[$this->line_count][$cell_count] = $cell;
			$cell_count++;
		}
		$this->cell_count = $cell_count;
	}
	function calc_row()
	{
		if ( $this->row == 'sum' || $this->row == 'average' ){		//row
			if ($this->row == 'sum') $cell_calc = array_sum( $this->cells[$this->line_count] );
			if ($this->row == 'average') $cell_calc = $this->avg();
			$this->cells[$this->line_count][$this->cell_count] = $cell_calc;
			$this->body_table .= $this->format($cell_calc);
			$this->cell_count++;
		}
	}
	function avg()
	{
		if ( $this->calc_cell_count === 0 ){
			return '';
		} else {
			return array_sum($this->cells[$this->line_count]) / $this->calc_cell_count;
		}
	}
	function format($cell_calc)
	{
		return $this->cell_format . number_format((float) $cell_calc, $this->dot, '.', $this->comma) . '|';
	}
	function calc_column($cell_count_max)
	{
		for ( $x = 1 ;$x < $cell_count_max ;$x++){
			$cell_column = 0;
			for ( $y = 1 ;$y < $this->line_count ;$y++){
				$cell_column += $this->cells[$y][$x];
			}
			if ($this->column == 'sum' ) {
				$cell_calc = $cell_column;
			} else if ($this->column == 'average'){
				$cell_calc = $cell_column / ( $this->line_count - 1);
			}
			$body .= $this->format($cell_calc);
		}
		return $body;
	}
//}
//class TableEdit2Func extends TableEdit2Calc
//{
	function cell_func($matc_cell,$cell_count,$cell)
	{
		$func_s = $func_r = array();
		for ($i=0; $i< count($matc_cell[0]); $i++) {
			$func_name = "sum_r sum_c cell cell_ra avg_r avg_c count_r count_c max_r max_c min_r min_c";
			if ( preg_match("/\b" . $matc_cell[1][$i] . "\b/i", $func_name ) ) {
				$cell_func = call_user_func_array( array('TableEdit2Func', strtolower($matc_cell[1][$i])),array($matc_cell[2][$i],$matc_cell[3][$i],$this->cells,$this->line_count,$cell_count));
			}
			$func_s[$i] = '/\@' . $matc_cell[1][$i] . '\(' . $matc_cell[2][$i] . ',' . $matc_cell[3][$i] . '\)/';
			$func_r[$i] = '' . $cell_func . '';
		}
		$cell = preg_replace($func_s, $func_r, $cell);
		return $cell;
	}
}
class TableEdit2Func
{
	function sum_r($start,$end,$cells,$line_count,$cell_count)
	{
		$cell_sum = 0;
		for ( $x = $start;$x <= $end;$x++){
			$cell_sum += $cells[$line_count][$x];
		}
		return $cell_sum;
	}
	function sum_c($start,$end,$cells,$line_count,$cell_count)
	{
		$cell_sum = 0;
		for ( $x = $start;$x <= $end;$x++){
			$cell_sum += $cells[$x][$cell_count];
		}
		return $cell_sum;
	}
	function cell($row,$column,$cells,$line_count,$cell_count)
	{
		$cell = $cells[$row][$column];
		return $cell;
	}
	function cell_ra($row,$column,$cells,$line_count,$cell_count)
	{
		$cell = $cells[$line_count - $row][$cell_count - $column];
		return $cell;
	}
	function avg_r($start,$end,$cells,$line_count,$cell_count)
	{
		$cell_sum = 0;
		$sum_count = 0;
		for ( $x = $start;$x <= $end;$x++){
			$cell_sum += $cells[$line_count][$x];
			if (is_numeric($cells[$line_count][$x])){
				$sum_count++;
			}
		}
		$cell_avg = ( $sum_count === 0 ) ? '' : $cell_sum / $sum_count;
		return $cell_avg;
	}
	function avg_c($start,$end,$cells,$line_count,$cell_count)
	{
		$cell_sum = 0;
		$sum_count = 0;
		for ( $x = $start;$x <= $end;$x++){
			$cell_sum += $cells[$x][$cell_count];
			if (is_numeric($cells[$x][$cell_count])){
				$sum_count++;
			}
		}
		$cell_avg = ( $sum_count === 0 ) ? '' : $cell_sum / $sum_count;
		return $cell_avg;
	}
	function count_r($start,$end,$cells,$line_count,$cell_count)
	{
		$count = 0;
		for ( $x = $start;$x <= $end;$x++){
			if (is_numeric($cells[$line_count][$x])){
				$count++;
			}
		}
		return $count;
	}
	function count_c($start,$end,$cells,$line_count,$cell_count)
	{
		$count = 0;
		for ( $x = $start;$x <= $end;$x++){
			if (is_numeric($cells[$x][$cell_count])){
				$count++;
			}
		}
		return $count;
	}
	function max_r($start,$end,$cells,$line_count,$cell_count)
	{
		$max_cell = $cells[$line_count][$start];
		$start++;
		for ( $x = $start;$x <= $end;$x++){
			if ($max_cell < $cells[$line_count][$x]){
				$max_cell = $cells[$line_count][$x];
			}
		}
		return $max_cell;
	}
	function max_c($start,$end,$cells,$line_count,$cell_count)
	{
		$max_cell = $cells[$start][$cell_count];
		$start++;
		for ( $x = $start;$x <= $end;$x++){
			if ($max_cell < $cells[$x][$cell_count]){
				$max_cell = $cells[$x][$cell_count];
			}
		}
		return $max_cell;
	}
	function min_r($start,$end,$cells,$line_count,$cell_count)
	{
		$min_cell = $cells[$line_count][$start];
		$start++;
		for ( $x = $start;$x <= $end;$x++){
			if ($min_cell > $cells[$line_count][$x]){
				$min_cell = $cells[$line_count][$x];
			}
		}
		return $min_cell;
	}
	function min_c($start,$end,$cells,$line_count,$cell_count)
	{
		$min_cell = $cells[$start][$cell_count];
		$start++;
		for ( $x = $start;$x <= $end;$x++){
			if ($min_cell > $cells[$x][$cell_count]){
				$min_cell = $cells[$x][$cell_count];
			}
		}
		return $min_cell;
	}
}
class TableEdit2Sort
{
	var $sortabletableso;

	function sort($sort_opt, $r_cell_count)
	{
		if ($sort_opt == '') {
			$this->sortabletableso = join(',', array_fill(0, $r_cell_count, "'String'"));
		} else {
			$st_so = explode("|", $sort_opt);
			$st_so = preg_replace('/^(\S{1})/e',"strtoupper('\\1')",$st_so); //>> ucfirst
//			$st_so = ucfirst($st_so);
			$this->sortabletableso = "'" . array_shift($st_so) . "'";
			foreach ($st_so as $st_so_c) {
				$this->sortabletableso .= ",'" . $st_so_c . "'";
			}
		}
	}
}
function plugin_table_edit2_inline()
{
	global $vars, $edit_auth_pages;
	$script_uri = get_script_uri();
	$page = isset($vars['page']) ? $vars['page'] : '';
	$r_page = rawurlencode($page);
	$body = '';
	if (! function_exists('_')) table_edit2_message();

	$s_table_edit = _('edit');
	$s_table_add  = _('addition');

	$args = func_get_args();
	foreach ($args as $opt_key) {
		list($key, $val) = explode('=', strtolower($opt_key));
		$opt[$key] = htmlspecialchars($val);
	}

	$add_show = '';
	$edit_mod = $opt['edit_mod'];
	if (PLUGIN_TABLE_EDIT2_ADD_SHOW && ( $edit_mod == 'td' || $edit_mod == 'tr' )) {
		if ($edit_mod == 'tr') $edit_mod = 'show';
		if ($edit_mod == 'td') $edit_mod = 'tdshow';
		$add_show = '&amp;add_show=1';
	}

	if ($opt['edit_mod'] == 'show' || $opt['edit_mod'] == 'tdshow'){
		$image_png = 'paraedit.png" width="9" height="9" alt="" title="' . $s_table_edit . '"';
	} else if ($opt['edit_mod'] == 'tr' || $opt['edit_mod'] == 'td'){
		$image_png = 'mini_add.png" width="8" height="8" alt="" title="' . $s_table_add . '"';
	}
	$body .= '<a href="' . $script_uri . "?plugin=table_edit2&amp;refer=$r_page&amp;edit_mod="
		 . $edit_mod . "&amp;table_num=" . $opt['table_num'] . "&amp;table_sub_num=" . $opt['table_sub_num']
		 . "&amp;line_count=" . $opt['line_count'] . "&amp;cell_count=" . $opt['cell_count'] . $add_show
		 . '"><img src="' . IMAGE_URI . 'plus/' . $image_png . ' /></a>';
	return $body;
}
function plugin_table_edit2_action()
{
	global $vars, $post, $auth_users, $realm;
	$table_num = 	$vars['table_num'];
	$page = 		$vars['refer'];

	if (isset($vars['cancel'])) {
		header('Location: ' . $script_uri . '?' . rawurlencode($page) . '#' . "TableEdit2TableNumber$table_num");
		exit;
		return;
	}

	$script_uri = get_script_uri();
	$line_count = 1;
	$table_sub_num = 1;			//td 06.09.18
	$table_sub_num_chk = 1;		//td 06.09.18
	$t_type = PLUGIN_TABLE_EDIT2_TEXTAREA;			//textarea 06.11.13

	if (! function_exists('_')) table_edit2_message();

	$td_edit = ($vars['edit_mod'] == 't_edit_td' || $vars['edit_mod'] == 'td') ? 1 : 0;
	$tr_edit = ($vars['edit_mod'] == 't_edit' || $vars['edit_mod'] == 'tr') ? 1 : 0;
	$t_edit = ($vars['edit_mod'] == 't_edit_td' || $vars['edit_mod'] == 't_edit') ? 1 : 0;
	$edit_show = ($vars['edit_mod'] == 'tdshow' || $vars['edit_mod'] == 'show') ? 1 : 0;

	// Petit SPAM Check (Client(Browser)-Server Ticket Check)
	$spam = FALSE;
	if (! function_exists('honeypot_write') && $t_edit )
		 $spam = plugin_table_edit2_spam($post['encode_hint']);
	if ($spam) return plugin_table_edit2_honeypot();

	if (! class_exists('auth')) { table_edit2_auth(); }
	if (auth::check_role('readonly')) die_message('PKWK_READONLY prohibits editing');
	if (! function_exists('path_check')) {
		if (! ereg('^(' . $script_uri . ')',$_SERVER['HTTP_REFERER'])) return;
	} else {
		if (! path_check($script_uri,$_SERVER['HTTP_REFERER'])) return;	//06.09.11 upk
	}

	if ( isset($vars['table_mod']) ) $chg = new TableEdit2TableMod($vars['table_mod']);
	if ( $td_edit || $tr_edit ) $edit = new TableEdit2Edit( $vars );
	if ( $edit_show ) $show = new TableEdit2Show( $vars, $page );

	$args  = get_source($page);
	static $count = 0;
	$source_s = '';
	$body = '';

	if( $td_edit || $tr_edit )
		$edit->notimestamp = (isset($vars['notimestamp'])) ? TRUE : FALSE;

	foreach ($args as $args_line) {

		if(preg_match('/^#([^\(\{]+)(?:\(([^\r]*)\))?(\{*)/', $args_line, $matches) && $matches[1] == 'table_edit2') {
			$table_find = 1;
			$count++;
			if( $line_count === 1 && $count == $table_num ){

				if(preg_match('/auth_check[=_](on|off)/i',$matches[2],$auth_check)) {
					if ( $auth_check[1] == 'on' ) {
						if (!auth::auth_pw($auth_users))
						{
							unset($_SERVER['PHP_AUTH_USER'], $_SERVER['PHP_AUTH_PW']);
							header( 'WWW-Authenticate: Basic realm="'.$realm.'"' );
							header( 'HTTP/1.0 401 Unauthorized' );
							$user = auth::check_auth();
							if(empty($user)) return;
						}
					}
				} else {
					check_editable($page, true, true);
				}

				if($vars['edit_mod'] == 'tdshow')		//tdshow - td_title - 06.11.11
					if(preg_match('/title_c=(\d+)/i',$matches[2],$match_title))
						$td_title_count = $match_title[1] - 1;

				if( $edit_show ) $show->text_type( $matches[2] );

				if ( isset($vars['table_mod']) ){		//table_mod
					$notimestamp = TRUE;
					$args_line = $chg->table_mod_chg($matches, $args_line);
				}
			}
			$end_line = strlen($matches[3]);
		}

		if (preg_match('/^\}{' . $end_line . '}/', $args_line)) $table_find = 0;

		if($table_find && $table_num == $count){
			if (preg_match('/^\|(.+)\|([hHfFcC]?)$/', $args_line, $match_line)){

				if ($table_sub_num == $vars['table_sub_num'] && $table_sub_num_chk){		//td 06.09.18
					$show->chk_table_sub_first_line = $line_count;
					$table_sub_num_chk = 0;
				}

				if ($vars['line_count'] == $line_count || strtolower( $match_line[2] ) == 'h' || $vars['edit_mod'] == 'tdshow' || $td_edit){
					$match_t = explode("|", $match_line[1]);	//move 06.09.16
					if($vars['edit_mod'] == 'tdshow')		//tdshow - td_title - 06.11.11
						$show->td_title[$line_count] = $match_t[$td_title_count];
				}

				if($vars['edit_mod'] == 'show')					//show				header
					if($match_line[2] == 'h') $show->table_header($match_t);

				if ( $vars['line_count'] == $line_count || $table_sub_num == $vars['table_sub_num'] )		// textarea 06.11.12
					if( $edit_show )
						if (! isset($show->text_type) ) $show->text_type = array_fill(0, count($match_t), $show->t_type);

				if ( $td_edit && $table_sub_num_chk == 0 && $table_sub_num == $vars['table_sub_num'])
				{
					$source_s .= $edit->td_edit( $match_t ) . $match_line[2] . "\n";
					$table_sub_num_count_chk = 1;

				} else if($vars['line_count'] == $line_count)
				{
					if( $tr_edit ) {				//t_edit tr_add
						if ($vars['add_show']) $source_s .= $args_line;
						$source_s .= $edit->tr_edit($args_line, $match_t, $match_line[2]);

					} else if( $edit_show ){		//show or tdshow
						$show->line_count = $line_count;
						$body = $show->show_mod($match_t);
					}

				} else {
					if ($vars['edit_mod'] == 'tdshow')		//tdshow and edit_td
						$show->cells[$line_count] = $match_t;

					$table_sub_num_count_chk = 1;			//td06.09.18
					$source_s .= $args_line;
				}
				$line_count++;
			} else {
				if ($table_sub_num_count_chk == 1){			//td 06.09.18
					$table_sub_num++;
					$table_sub_num_count_chk = 0;
				}
				$source_s .= $args_line;
			}
		} else {
			$source_s .= $args_line;
		}
	}

	if ($td_edit || $tr_edit) $notimestamp = $edit->notimestamp;
	if ($tr_edit || $td_edit || isset($vars['table_mod']))
		page_write($page, $source_s, $notimestamp);

	$post['refer'] = $page;

	if ( $edit_show ) return array('msg'=>$this->title, 'body'=>$body);

	header('Location: ' . $script_uri . '?' . rawurlencode($page) . '#' . "TableEdit2TableNumber$table_num");	//1.0	06.09.20
	exit;
}
class TableEdit2TableMod
{
	var $table_mod;
	var $search_r = array ();
	var $replace_r = array ();
	
	function TableEdit2TableMod($mod)
	{
		$this->table_mod = $mod;
		if ($this->table_mod == 'close'){
			$this->search_r = array ('@table_mod=open@si');
			$this->replace_r = array ('table_mod=close');
		} else if ($this->table_mod == 'open') {
			$this->search_r = array ('@table_mod=close@si');
			$this->replace_r = array ('table_mod=open');
		}
	}
	function table_mod_chg($matches, $args_line)
	{
		if(preg_match('/(table_mod)/',$matches[2])){
			return preg_replace($this->search_r, $this->replace_r, $args_line);
		} else {
			return "#table_edit2(" . $matches[2] . ",table_mod=" . $this->table_mod . ")" . $matches[3] . "\n";
		}
	}
}
class TableEdit2Edit
{
	var $opt = array();
	var $line_count_td = 1;
	var $notimestamp = FALSE;

	function TableEdit2Edit($post_opt)
	{
		$this->opt = $post_opt;
	}
	function td_edit($match_t)
	{
		$end_cell = count ($match_t);
		$source_s = '|';
		for ($x = 0;$x < $end_cell;$x++){
			if ($x == ($this->opt['cell_count'] - 1)){
				if (isset($this->opt['delete'])){
					$source_s .= '';
				} else if ($this->opt['edit_mod'] == 'td'){
					$source_s .= $match_t[$x] . '||';
					$this->notimestamp = TRUE;
				} else {
					if ($this->opt['add_show']) $source_s .= $match_t[$x] . '|';
					$source_s .= $this->textarea_br($this->line_count_td);
				}
			} else {
				$source_s .= $match_t[$x] . '|';
			}
		}
		$this->line_count_td++;
		return $source_s;
	}
	function tr_edit($args_line, $match_t, $last_character)
	{
		if($this->opt['edit_mod'] == 'tr') $source_s = $args_line;	//tr_add
		$source_s .= (isset($this->opt['delete'])) ? '' : '|';
		if($this->opt['edit_mod'] == 't_edit'){				//t_edit
			if(isset($this->opt['write'])){
				for ($i = 1;$i < $this->opt['cell_count'];$i++){
					$source_s .= $this->textarea_br($i);
				}
				$source_s .= ($this->opt['add_show']) ? "\n" : $last_character . "\n";
			}
		} else if($this->opt['edit_mod'] == 'tr'){			//tr	tr_add
			$this->notimestamp = TRUE;
			foreach ($match_t as $cell){
				$source_s .= '|';
			}
			$source_s .= "\n";
		}
		return $source_s;
		
	}
	function textarea_br($cell_number)
	{
		$w_cell = $this->opt['cell' . $cell_number];
		$w_cell = str_replace("\n", '&br;', str_replace("\r",'',$w_cell));
		return $w_cell . '|';
	}
}
class TableEdit2Show extends TableEdit2Form
{
	var	$title = '';
	var $opt = array();
	var $textarea_chk;
	var $t_type;
	var $text_type;
	var $table_header = array();
	var $page;
	var $chk_table_sub_first_line;
	var $td_title;
	var $line_count;
	var $cells;
	var $input_bg_color = array();
	var $add_title;

	function TableEdit2Show( $post_opt, $page )
	{
		$this->opt = $post_opt;
		$this->page = $page;
		$this->add_title = ($this->opt['add_show']) ? _(' [Add Mode]'): '';
	}
	function text_type($pi_opt)
	{
		$this->textarea_chk = PLUGIN_TABLE_EDIT2_TEXTAREA ;
		if(preg_match('/textarea/i',$pi_opt)) $this->t_type = 'textarea';
		if(preg_match('/form=(.*?),/i',$pi_opt,$match_form))
			$this->text_type = explode("|", $match_form[1]);
		if(preg_match('/input_bg_color=(.*?),/i',$pi_opt,$match_color))
			$this->input_bg_color = explode("|", $match_color[1]);
	}
	function table_header($cells)
	{
		$cell_count = 1;
		foreach ($cells as $cell){
			$this->table_header[$cell_count] = $cell;
			$cell_count++;
		}
	}
	function show_mod($cells_t)
	{
		if($this->opt['edit_mod'] == 'show'){				//show
			$this->title = 'table_edit2 ' . $this->page;
			return $this->table_edit_form( $this->line_count, $cells_t);

		} else if($this->opt['edit_mod'] == 'tdshow'){			//tdshow
			$this->cells[$this->line_count] = $cells_t;
			$column_num = $this->opt['cell_count'] - 1;
			$x_count = 1;
			for ( $x = $this->chk_table_sub_first_line ;$x <= $this->line_count ; $x++){
				$column_cell[$x] = $this->cells[$x][$column_num];
				$this->table_header[$x_count] = $this->td_title[$x];
				$x_count++;
			}
			$this->text_type = array_fill(0, $x_count, $this->text_type[$this->opt['cell_count'] - 1]);	//form 06.11.13
			$this->title = 'table_edit2 ' . $this->page;
			return $this->table_edit_form( $this->opt['cell_count'], $column_cell);
		}
	}
	//table edit form
	function table_edit_form( $edit_count, $edit_cell )
	{

	$helptags = (function_exists('edit_form_assistant')) ? edit_form_assistant() : '';	//06.11.15 assistant
	$helpdiv  = (helptags == '') ? '' : ' onmouseup="pukiwiki_pos()" onkeyup="pukiwiki_pos()"';
	$s_table_ok       = _('OK');
	$s_table_cancel     = _('cancel');
	$s_table_delete     = _('delete');
	$s_table_time_stamp = _('no time stamp');
	$s_table_title      = _('table');
	$s_table_line       = _('line');
	$s_table_column     = _('column line');
	$script_uri = get_script_uri();
	$table_num     = $this->opt['table_num'];
	$table_sub_num = $this->opt['table_sub_num'];

	if ($this->opt['edit_mod'] == 'show'){
		$line_name = " $s_table_line";
		$edit_mod = 't_edit';
		$x_count = 'line_count';
		$y_count = 'cell_count';
	} else if ($this->opt['edit_mod'] == 'tdshow'){
		$line_name = " (sub number=" . $table_sub_num . ") $s_table_column";
		$edit_mod = 't_edit_td';
		$x_count = 'cell_count';
		$y_count = 'line_count';
	}

	$this->bgcolor($this->input_bg_color);

	$body = <<<EOD
<h3>$s_table_title=$table_num$line_name=$edit_count{$this->add_title}</h3>
<form action="$script_uri" method="post">
 <div class="commentform"$helpdiv>
  <table cellspacing="0" cellpadding="2" class="style_table">
EOD;

	$cell_count = 1;
	foreach ($edit_cell as $cell){

		if ($this->opt['add_show']) $cell = '';
	
		$body .= '  <tr><td>' . $this->table_header[$cell_count] . '(' . $cell_count . ')</td><td class="style_td">';
		$input_text = $this->text(
			'cell' . $cell_count,
			htmlspecialchars($cell),
			PLUGIN_TABLE_EDIT2_TEXT_SIZE) . '</td></tr>' . "\n";
		
		if($this->text_type[$cell_count - 1] == 'textarea'){		// textarea 06.11.12
			$cell = htmlspecialchars(preg_replace(array("[&br;]"), array("\n"), $cell));	// textarea 06.11.13
			$body .= $this->textarea(
				'cell' . $cell_count,
				 $cell,
				 PLUGIN_TABLE_EDIT2_TEXTAREA_ROWS_LINE,
				 PLUGIN_TABLE_EDIT2_TEXTAREA_COLS_SIZE) . "\n";

		} else if(preg_match('/select=(.*)/i',$this->text_type[$cell_count - 1],$select_data)){		// select 06.11.14

			$select_data = explode("_", $select_data[1]);
			$this->select_chk = 0;
			$select = $this->select($select_data, 'cell' . $cell_count, $cell);
			$body .= ( $this->select_chk ) ? $select : $input_text;

		} else if(preg_match('/radio=(.*)/i',$this->text_type[$cell_count - 1],$radio_data)){		// radio 06.11.14

			$radio_data = explode("_", $radio_data[1]);
			$this->radio_chk = 0;
			$radio = $this->radio($radio_data, 'cell' . $cell_count, $cell);
			$body .= ( $this->radio_chk ) ? $radio : $input_text;

		} else {		// text 06.11.12
			$body .= $input_text;
		}
		$cell_count++;
	}
	
	$delete_or_addshow = ($this->opt['add_show']) ?
		$this->f_input('hidden','add_show', 1) :
		$this->f_input('submit','delete',$s_table_delete) ;
	
	$body .= <<<EOD
  <tr><td  colspan="2">
   <input type="hidden" name="plugin"        value="table_edit2" />
   <input type="hidden" name="refer"         value="{$this->page}" />
   <input type="hidden" name="table_num"     value="$table_num" />
   <input type="hidden" name="table_sub_num" value="$table_sub_num" />
   <input type="hidden" name="$x_count"      value="$edit_count" />
   <input type="hidden" name="$y_count"      value="$cell_count" />
   <input type="hidden" name="edit_mod"      value="$edit_mod" />
   <input type="submit" name="write"         value="$s_table_ok" />
   <input type="submit" name="cancel"  value="$s_table_cancel" />
   $delete_or_addshow $s_table_time_stamp
   <input type="checkbox" name="notimestamp" />
   $helptags
  </td></tr>
 </table>
 </div>
</form>
EOD;
	return $body;
	}
}
function plugin_table_edit2_spam($hint)
{
	if (isset($hint) && $hint != '') {
		if (PKWK_ENCODING_HINT != $hint) return TRUE;
	} else {
		if (PKWK_ENCODING_HINT != '') return TRUE;
	}
}
function plugin_table_edit2_honeypot()
{
	// Logging for SPAM Report
	honeypot_write();

	// Same as "Cancel" action
	return array('msg'=>'', 'body'=>''); // Do nothing
}

?>
